searchNodes=[{"doc":"The following are the main Bitcraft components:Bitcraft.BitBlock - This is the main Bitcraft component. It provides a DSL that allows to define bit-blocks with their segments (useful for building binary protocols) and automatically injects encoding and decoding functions for them.Bitcraft - This is a helper module that provides utility functions to work with bit strings and binaries.","ref":"Bitcraft.html","title":"Bitcraft","type":"module"},{"doc":"Returns the number of 1s in binary representation of the given integer.Exampleiex&gt; Bitcraft.count_ones(15) 4 iex&gt; Bitcraft.count_ones(255) 8","ref":"Bitcraft.html#count_ones/1","title":"Bitcraft.count_ones/1","type":"function"},{"doc":"Returns a tuple {decoded value, leftover} where the first element is the decoded value from the given input (according to the given otps too) and the second element is the leftover.Options:size - The size in bits to decode. Defaults to byte_size(input) * 8. If the type is Bitcraft.BitBlock.Array.(), the size should match with array_length * element_size.:type - The segment type given by Bitcraft.segment_type(). Defaults to :integer.:sign - If the input is an integer, defines if it is :signed or :unsigned. Defaults to :unsigned.:endian - Applies to utf32, utf16, float, integer. Defines the endianness, :big or :little. Defaults to :big.Exampleiex&gt; 3 ...&gt; |&gt; Bitcraft.encode_segment(size: 4) ...&gt; |&gt; Bitcraft.decode_segment(size: 4) {3, &quot;&quot;} iex&gt; -3.3 ...&gt; |&gt; Bitcraft.encode_segment(size: 64, type: :float, sign: :signed) ...&gt; |&gt; Bitcraft.decode_segment(size: 64, type: :float, sign: :signed) {-3.3, &quot;&quot;} iex&gt; &quot;test&quot; ...&gt; |&gt; Bitcraft.encode_segment(type: :binary) ...&gt; |&gt; Bitcraft.decode_segment(size: 4, type: :binary) {&quot;test&quot;, &quot;&quot;} iex&gt; &lt;&lt;1, 2, 3, 4&gt;&gt; ...&gt; |&gt; Bitcraft.encode_segment(type: :bits) ...&gt; |&gt; Bitcraft.decode_segment(size: 32, type: :bits) {&lt;&lt;1, 2, 3, 4&gt;&gt;, &quot;&quot;} iex&gt; alias Bitcraft.BitBlock.Array iex&gt; [1, 2] ...&gt; |&gt; Bitcraft.encode_segment(type: %Array{}) ...&gt; |&gt; Bitcraft.decode_segment(size: 16, type: %Array{}) {[1, 2], &quot;&quot;} iex&gt; [3.3, -7.7, 9.9] ...&gt; |&gt; Bitcraft.encode_segment( ...&gt; type: %Array{type: :float, element_size: 64}, ...&gt; sign: :signed ...&gt; ) ...&gt; |&gt; Bitcraft.decode_segment( ...&gt; size: 192, ...&gt; type: %Array{type: :float, element_size: 64}, ...&gt; sign: :signed ...&gt; ) {[3.3, -7.7, 9.9], &quot;&quot;}","ref":"Bitcraft.html#decode_segment/2","title":"Bitcraft.decode_segment/2","type":"function"},{"doc":"","ref":"Bitcraft.html#decode_segment/5","title":"Bitcraft.decode_segment/5","type":"function"},{"doc":"Encodes the given input into a bitstring.Options:size - The size in bits for the input to encode. The default value depend on the type, for integer is 8, for float is 63, and for other data types is nil. If the input is a list, this option is skipped, since it is handled as array and the size will be array_length * element_size.:type - The segment type given by Bitcraft.segment_type(). Defaults to :integer.:sign - If the input is an integer, defines if it is :signed or :unsigned. Defaults to :unsigned.:endian - Applies to utf32, utf16, float, integer. Defines the endianness, :big or :little. Defaults to :big.Exampleiex&gt; Bitcraft.encode_segment(15) &lt;&lt;15&gt;&gt; iex&gt; Bitcraft.encode_segment(255, size: 4) &lt;&lt;15::size(4)&gt;&gt; iex&gt; Bitcraft.encode_segment(-3.3, size: 64, type: :float) &lt;&lt;192, 10, 102, 102, 102, 102, 102, 102&gt;&gt; iex&gt; Bitcraft.encode_segment(&quot;hello&quot;, type: :binary) &quot;hello&quot; iex&gt; Bitcraft.encode_segment(&lt;&lt;1, 2, 3&gt;&gt;, type: :bits) &lt;&lt;1, 2, 3&gt;&gt; iex&gt; Bitcraft.encode_segment([1, -2, 3], type: %Bitcraft.BitBlock.Array{ ...&gt; type: :integer, element_size: 4}, ...&gt; sign: :signed ...&gt; ) &lt;&lt;30, 3::size(4)&gt;&gt;","ref":"Bitcraft.html#encode_segment/2","title":"Bitcraft.encode_segment/2","type":"function"},{"doc":"","ref":"Bitcraft.html#encode_segment/5","title":"Bitcraft.encode_segment/5","type":"function"},{"doc":"","ref":"Bitcraft.html#t:base_type/0","title":"Bitcraft.base_type/0","type":"type"},{"doc":"Codable segment type","ref":"Bitcraft.html#t:codable_segment_type/0","title":"Bitcraft.codable_segment_type/0","type":"type"},{"doc":"Segment type","ref":"Bitcraft.html#t:segment_type/0","title":"Bitcraft.segment_type/0","type":"type"},{"doc":"Defines a bit-block.A bit-block is used to map a bitstring into an Elixir struct. The definition of the bit-block is possible through defblock/3.defblock/3 is typically used to decode bitstring from a bit stream, usually a binary protocol (e.g.: TCP/IP), into Elixir structs and vice-versa (encoding Elixir structs into a bitstring).Exampledefmodule MyBlock do import Bitcraft.BitBlock defblock &quot;my-static-block&quot; do segment(:h, 5, type: :binary) segment(:s1, 4, default: 1) segment(:s2, 8, default: 1, sign: :signed) segment(:t, 3, type: :binary) end endThe segment macro defines a segment in the bit-block with given name and size. Bit-blocks are regular structs and can be created and manipulated directly using Elixir's struct API:iex&gt; block = %MyBlock{h: &quot;begin&quot;, s1: 3, s2: -3, t: &quot;end&quot;} iex&gt; %{block | h: &quot;hello&quot;}By default, a bit-block will automatically generate the implementation for the callbacks encode/1 and decode/3. You can then encode the struct into a bitstring and then decode a bitstring into a Elixir struct, like so:iex&gt; bits = MyBlock.encode(block) iex&gt; data = MyBlock.decode(bits)What we defined previously it is a static block, means a fixed size always. This is the easiest scenario because we don't need to provide any additional logic to the the encode/1 and decode/3 functions. For that reason, in the example above, we call decode function only with the input bitstring, the other arguments are not needed since they are ment to resolve the size for dynamic segments.Dynamic SegmentsThere are other scenarios where the block of bits is dynamic, means the size of the block is variable and depends on other segment values to calculate the size, this makes it more complicated to decode it. For those variable blocks, we can define dynamic segments using the segment/3 API:segment(:var, :dynamic, type: :bits)As you can see, for the size argument we are passing :dynamic atom. In this way, the segment is marked as dynamic and its size is resolved later during the decoding process.The following is a more elaborate example of block. We define an IPv4 datagram which has a static and a dynamic part. The dynamic part is basically the options and the data. The block can be defined as:defmodule IpDatagram do @moduledoc false import Bitcraft.BitBlock defblock &quot;IP-datagram&quot; do segment(:vsn, 4) segment(:hlen, 4) segment(:srvc_type, 8) segment(:tot_len, 16) segment(:id, 16) segment(:flags, 3) segment(:frag_off, 13) segment(:ttl, 8) segment(:proto, 8) segment(:hdr_chksum, 16, type: :bits) segment(:src_ip, 32, type: :bits) segment(:dst_ip, 32, type: :bits) segment(:opts, :dynamic, type: :bits) segment(:data, :dynamic, type: :bits) end # Size resolver for dynamic segments invoked during the decoding def calc_size(%__MODULE__{hlen: hlen}, :opts, dgram_s) when hlen &gt;= 5 and 4 * hlen &lt;= dgram_s do opts_s = 4 * (hlen - 5) {opts_s * 8, dgram_s} end def calc_size(%__MODULE__{leftover: leftover}, :data, dgram_s) do data_s = :erlang.bit_size(leftover) {data_s, dgram_s} end endHere, the segment corresponding to the :opts segment has a type modifier, specifying that :opts is to bind to a bitstring (or binary). All other segments have the default type equal to unsigned integer.An IP datagram header is of variable length. This length is measured in the number of 32-bit words and is given in the segment corresponding to :hlen. The minimum value of :hlen is 5. It is the segment corresponding to :opts that is variable, so if :hlen is equal to 5, :opts becomes an empty binary. Finally, the tail segment :data bind to bitstring.The decoding of the datagram fails if one of the following occurs:The first 4-bits segment of datagram is not equal to 4.:hlen is less than 5.The size of the datagram is less than 4*hlen.Since this block has dynamic segments, we can now use the other decode arguments to resolve the size for them during the decoding process:IpDatagram.decode(bits, :erlang.bit_size(bits), &amp;IpDatagram.calc_size/3)Where:The first argument is the input IPv4 datagram (bitstring).The second argument is is the accumulator to the callback function (third argument), in this case is the total number of bits in the datagram.And the third argument is the function callback or dynamic size resolver that will be invoked by the decoder for each dynamic segment. The callback functions receives the data struct with the current decoded segments, the segment name (to be pattern-matched and resolve its size), and the accumulator that can be used to pass metadata during the dynamic segments evaluation.ReflectionAny bit-block module will generate the __bit_block__ function that can be used for runtime introspection of the bit-block:__bit_block__(:name) - Returns the name or alias as given to defblock/3.__bit_block__(:segments) - Returns a list of all segments names.__schema__(:segment_info, segment) - Returns a map with the segment info.Working with typespecsBy default, the typespec t/0 is generated but in the simplest form:@type t :: %__MODULE__{}If you want to provide a more accurate typespec for you block adding the typespecs for each of the segments on it, you can set the option :typespec to false when defining the block, like so:defblock &quot;my-block&quot;, typespec: false do ... end","ref":"Bitcraft.BitBlock.html","title":"Bitcraft.BitBlock","type":"behaviour"},{"doc":"This is a helper function used internally for building a block segment.","ref":"Bitcraft.BitBlock.html#__segment__/4","title":"Bitcraft.BitBlock.__segment__/4","type":"function"},{"doc":"Same as segment/3, but automatically generates a dynamic segment with the type Bitcraft.BitBlock.Array.t().The size of the array-type segment in bits has to be calculated dynamically during the decoding, and the length of the array will be segment_size/element_size. This process is performs automatically during the decoding. hence, it is important to set the right element_size and also implement properly the callback to calculate the segment size. See Bitcraft.BitBlock.dynamic_size_resolver().OptionsOptions are the same as segment/3, and additionally::element_size - The size in bits of each array element. Defaults to 8.NOTE: The :type is the same as segment/3 BUT it applies to the array element.","ref":"Bitcraft.BitBlock.html#array/2","title":"Bitcraft.BitBlock.array/2","type":"macro"},{"doc":"","ref":"Bitcraft.BitBlock.html#block_segment/1","title":"Bitcraft.BitBlock.block_segment/1","type":"macro"},{"doc":"","ref":"Bitcraft.BitBlock.html#block_segment/2","title":"Bitcraft.BitBlock.block_segment/2","type":"macro"},{"doc":"This is a helper function used internally for building the encoding expressions.","ref":"Bitcraft.BitBlock.html#build_encoding_exprs/3","title":"Bitcraft.BitBlock.build_encoding_exprs/3","type":"function"},{"doc":"Decodes the given bitstring into the corresponding data type.Exampleiex&gt; block = %MyBlock{seg1: 1, seg: 2} iex&gt; bits = MyBlock.encode(block) iex&gt; MyBlock.decode(bits)","ref":"Bitcraft.BitBlock.html#c:decode/3","title":"Bitcraft.BitBlock.decode/3","type":"callback"},{"doc":"Internal helper for decoding the block segments.","ref":"Bitcraft.BitBlock.html#decode_segments/4","title":"Bitcraft.BitBlock.decode_segments/4","type":"function"},{"doc":"Defines a bit-block struct with a name and segment definitions.","ref":"Bitcraft.BitBlock.html#defblock/3","title":"Bitcraft.BitBlock.defblock/3","type":"macro"},{"doc":"Encodes the given data type into a bitstring.Exampleiex&gt; block = %MyBlock{seg1: 1, seg: 2} iex&gt; MyBlock.encode(block)","ref":"Bitcraft.BitBlock.html#c:encode/1","title":"Bitcraft.BitBlock.encode/1","type":"callback"},{"doc":"Internal helper for encoding the block segments.","ref":"Bitcraft.BitBlock.html#encode_segments/2","title":"Bitcraft.BitBlock.encode_segments/2","type":"function"},{"doc":"Defines a segment on the block with a given name and size.See Kernel.SpecialForms.&lt;&lt;&gt;&gt;/1 for more information about the segment types, size, unit, and so on.Options:type - Defines the segment data type the set of bits will be mapped to. See Kernel.SpecialForms.&lt;&lt;&gt;&gt;/1 for more information about the segment data types. Defaults to :integer.:sign - Applies only to integers and defines whether the integer is :signed or :unsigned. Defaults to :unsigned.:endian - Applies to utf32, utf16, float, integer. Defines the endianness, :big or :little. Defaults to :big.:default - Sets the default value on the block and the struct. The default value is calculated at compilation time, so don't use expressions for generating values dynamically as they would then be the same for all records. Defaults to nil.","ref":"Bitcraft.BitBlock.html#segment/3","title":"Bitcraft.BitBlock.segment/3","type":"macro"},{"doc":"Basic Segment types","ref":"Bitcraft.BitBlock.html#t:base_seg_type/0","title":"Bitcraft.BitBlock.base_seg_type/0","type":"type"},{"doc":"Block's segment type definition","ref":"Bitcraft.BitBlock.html#t:block_segment/0","title":"Bitcraft.BitBlock.block_segment/0","type":"type"},{"doc":"Resolver function for the size of dynamic segments.","ref":"Bitcraft.BitBlock.html#t:dynamic_size_resolver/0","title":"Bitcraft.BitBlock.dynamic_size_resolver/0","type":"type"},{"doc":"Segment type","ref":"Bitcraft.BitBlock.html#t:segment_type/0","title":"Bitcraft.BitBlock.segment_type/0","type":"type"},{"doc":"Bitblock definition","ref":"Bitcraft.BitBlock.html#t:t/0","title":"Bitcraft.BitBlock.t/0","type":"type"},{"doc":"Defines the type array.","ref":"Bitcraft.BitBlock.Array.html","title":"Bitcraft.BitBlock.Array","type":"module"},{"doc":"","ref":"Bitcraft.BitBlock.Array.html#t:t/0","title":"Bitcraft.BitBlock.Array.t/0","type":"type"},{"doc":"Defines a dynamic segment within a bit-block.","ref":"Bitcraft.BitBlock.DynamicSegment.html","title":"Bitcraft.BitBlock.DynamicSegment","type":"module"},{"doc":"","ref":"Bitcraft.BitBlock.DynamicSegment.html#t:t/0","title":"Bitcraft.BitBlock.DynamicSegment.t/0","type":"type"},{"doc":"Module for building extra helper functions.","ref":"Bitcraft.Helpers.html","title":"Bitcraft.Helpers","type":"module"},{"doc":"Helper function used internally for building decode_segment/5 function.","ref":"Bitcraft.Helpers.html#build_segment_decoder/0","title":"Bitcraft.Helpers.build_segment_decoder/0","type":"function"}]